.\"	$NetBSD: ld.so.conf.5,v 1.19 2009/04/10 14:57:28 joerg Exp $
.\"
.\" Copyright (c) 1996 Matthew R. Green
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
.\" BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
.\" LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
.\" AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
.\" OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.Dd July 21, 2004
.Dt LD.SO.CONF 5
.Os
.Sh NAME
.Nm ld.so.conf
.Nd run-time link-editor configuration file
.Sh DESCRIPTION
The
.Nm
file specifies additional default directories (beyond the standard set,
normally
.Dq Pa /usr/lib ) .
.Pp
On
.Xr a.out 5
systems, this file is scanned by
.Xr ldconfig 8
to create the hints files used by the run-time linker
.Pa /usr/libexec/ld.so
to locate shared libraries.
.Pp
On
.Xr elf 5
systems, this file is scanned directly by the run-time linker
.Pa /usr/libexec/ld.elf_so .
.Pp
Lines beginning with
.Sq #
are treated as comments and ignored.
Any other non-blank lines beginning
with
.Sq /
are stripped of leading whitespace and trailing comments
(introduced with
.Sq # )
together with any preceding whitespace, then treated as directories to be
scanned for shared libraries to add to the hints.
.Pp
On
.Xr elf 5
lines that do not begin with a
.Sq /
are parsed as hardware dependent per
library directives:
.Bd -literal
\*[Lt]library\*[Gt] \*[Lt]sysctl\*[Gt] \*[Lt]variable\*[Gt][,...]:\*[Lt]library\*[Gt][,...] ...
.Ed
.Pp
If there is no match, the standard action is taken.
.Sh FILES
.Pa /etc/ld.so.conf
.Sh EXAMPLES
.Bd -literal
libm.so.0	machdep.fpu_present	1:libm387.so.0,libm.so.0
.Ed
.Pp
The above line loads both libm387 and libm when the
.Xr sysctl 3
variable fpu_present has the value 1.
.Sh SEE ALSO
.Xr ld.aout_so 1 ,
.Xr ld.elf_so 1 ,
.Xr a.out 5 ,
.Xr elf 5 ,
.Xr ldconfig 8
.Sh HISTORY
The
.Nm
file appeared in
.Nx 1.3 .
The ELF support for it was added in
.Nx 1.5 .
.Sh BUGS
Directory names containing the comment character
.Pq Sq #
and/or leading or trailing whitespace cannot be included.
(Embedded blanks are allowed, however.)
